import  unicodedata
english_to_pahlavi_mapping = {
    'A': '𐎠', 'B': '𐎡', 'C': '𐎤', 'D': '𐎣', 'E': '𐎠',
    'F': '𐎦', 'G': '𐎥', 'H': '𐎢', 'I': '𐎡', 'J': '𐎤',
    'K': '𐎣', 'L': '𐎲', 'M': '𐎫', 'N': '𐎱', 'O': '𐎺',
    'P': '𐎡', 'Q': '𐎥', 'R': '𐎼', 'S': '𐎴', 'T': '𐎮',
    'U': '𐎺', 'V': '𐎺', 'W': '𐎺', 'X': '𐎤', 'Y': '𐎡',
    'Z': '𐎳',
    'a': '𐎠', 'b': '𐎡', 'c': '𐎤', 'd': '𐎣', 'e': '𐎠',
    'f': '𐎦', 'g': '𐎥', 'h': '𐎢', 'i': '𐎡', 'j': '𐎤',
    'k': '𐎣', 'l': '𐎲', 'm': '𐎫', 'n': '𐎱', 'o': '𐎺',
    'p': '𐎡', 'q': '𐎥', 'r': '𐎼', 's': '𐎴', 't': '𐎮',
    'u': '𐎺', 'v': '𐎺', 'w': '𐎺', 'x': '𐎤', 'y': '𐎡',
    'z': '𐎳'
}


english_to_manichaean_mapping = {
    'A': '𐫀', 'B': '𐫁', 'C': '𐫄', 'D': '𐫆', 'E': '𐫀',
    'F': '𐫌', 'G': '𐫍', 'H': '𐫅', 'I': '𐫓', 'J': '𐫄',
    'K': '𐫍', 'L': '𐫎', 'M': '𐫏', 'N': '𐫐', 'O': '𐫑',
    'P': '𐫡', 'Q': '𐫍', 'R': '𐫇', 'S': '𐫈', 'T': '𐫃',
    'U': '𐫑', 'V': '𐫑', 'W': '𐫑', 'X': '𐫄', 'Y': '𐫓',
    'Z': '𐫧',
    'a': '𐫀', 'b': '𐫁', 'c': '𐫄', 'd': '𐫆', 'e': '𐫀',
    'f': '𐫌', 'g': '𐫍', 'h': '𐫅', 'i': '𐫓', 'j': '𐫄',
    'k': '𐫍', 'l': '𐫎', 'm': '𐫏', 'n': '𐫐', 'o': '𐫑',
    'p': '𐫡', 'q': '𐫍', 'r': '𐫇', 's': '𐫈', 't': '𐫃',
    'u': '𐫑', 'v': '𐫑', 'w': '𐫑', 'x': '𐫄', 'y': '𐫓',
    'z': '𐫧'
}
english_to_manichaean_mapping.update(
    {
    '-': '𐎽', '/': '𐏁', '+': '𐏃', '÷': '𐏄', '!': '𐏂',
    '#': '𐏃', '%': '𐏀', '^': '𐎼', '$': '𐏅', '"': '𐎿',
    '>': '𐏆', '<': '𐏇', 'ء': '𐎠', 'أ': '𐎡', 'إ': '𐎢',
    'ؤ': '𐎣', 'ژ': '𐎤', 'ي': '𐎥', 'ة': '𐎦', 'ِ': '𐎧',
    'ّ': '𐎨', 'ۀ': '𐎩', 'آ': '𐎪', 'ـ': '𐎫', '؛': '𐎬',
    '،': '𐎭', 'ريال': '𐎮', ',': '𐎯', ']': '𐎰', '[': '𐎱',
    '\\': '𐎲', '»': '𐎳', '&': '𐎴', '*': '𐎵', '(': '𐎶',
    ')': '𐎷'
    # بقیه کاراکترهای خاص را می‌توان اضافه کرد
}
)

english_to_cuneiform_mapping = {
    'a': '𒀀', 'b': '𒁀', 'c': '𒄀', 'd': '𒁲', 'e': '𒂊',
    'f': '𒆳', 'g': '𒄖', 'h': '𒄩', 'i': '𒄿', 'j': '𒋛',
    'k': '𒆠', 'l': '𒇻', 'm': '𒈠', 'n': '𒉈', 'o': '𒌋',
    'p': '𒉿', 'q': '𒆥', 'r': '𒊑', 's': '𒊍', 't': '𒋗',
    'u': '𒌑', 'v': '𒅅', 'w': '𒉿', 'x': '𒍝', 'y': '𒅀',
    'z': '𒍣',
    'A': '𒀀', 'B': '𒁀', 'C': '𒄀', 'D': '𒁲', 'E': '𒂊',
    'F': '𒆳', 'G': '𒄖', 'H': '𒄩', 'I': '𒄿', 'J': '𒋛',
    'K': '𒆠', 'L': '𒇻', 'M': '𒈠', 'N': '𒉈', 'O': '𒌋',
    'P': '𒉿', 'Q': '𒆥', 'R': '𒊑', 'S': '𒊍', 'T': '𒋗',
    'U': '𒌑', 'V': '𒅅', 'W': '𒉿', 'X': '𒍝', 'Y': '𒅀',
    'Z': '𒍣'
}

persian_to_cuneiform_mapping = {
    'آ': '𒀀', 'ا': '𒀀', 'ب': '𒁀', 'پ': '𒁀', 'ت': '𒁲',
    'ث': '𒁲', 'ج': '𒄀', 'چ': '𒄀', 'ح': '𒄩', 'خ': '𒄩',
    'د': '𒁲', 'ذ': '𒁲', 'ر': '𒊑', 'ز': '𒍣', 'ژ': '𒍣',
    'س': '𒊍', 'ش': '𒊍', 'ص': '𒋗', 'ض': '𒋗', 'ط': '𒋗',
    'ظ': '𒋗', 'ع': '𒆳', 'غ': '𒆳', 'ف': '𒆥', 'ق': '𒆥',
    'ک': '𒆠', 'گ': '𒄖', 'ل': '𒇻', 'م': '𒈠', 'ن': '𒉈',
    'و': '𒌋', 'ه': '𒂊', 'ی': '𒅀'
}
persian_to_cuneiform_mapping.update(
    {
        'ئ''𐎠',
    }
)
persian_to_pahlavi_mapping = {
    'آ': '𐎠', 'ا': '𐎠', 'ب': '𐎡', 'پ': '𐎡', 'ت': '𐎮',
    'ث': '𐎮', 'ج': '𐎤', 'چ': '𐎤', 'ح': '𐎢', 'خ': '𐎢',
    'د': '𐎣', 'ذ': '𐎣', 'ر': '𐎼', 'ز': '𐎳', 'ژ': '𐎳',
    'س': '𐎴', 'ش': '𐎴', 'ص': '𐎧', 'ض': '𐎧', 'ط': '𐎧',
    'ظ': '𐎧', 'ع': '𐎦', 'غ': '𐎦', 'ف': '𐎦', 'ق': '𐎦',
    'ک': '𐎠', 'گ': '𐎵', 'ل': '𐎲', 'م': '𐎫', 'ن': '𐎱',
    'و': '𐎺', 'ه': '𐎺', 'ی': '𐎡'
}
persian_to_pahlavi_mapping.update(
    {
        'ئ''𐎠',
    }

)
persian_to_pahlavi_mapping.update(
       {
    '-': '𐎽', '/': '𐏁', '+': '𐏃', '÷': '𐏄', '!': '𐏂',
    '#': '𐏃', '%': '𐏀', '^': '𐎼', '$': '𐏅', '"': '𐎿',
    '>': '𐏆', '<': '𐏇', 'ء': '𐎠', 'أ': '𐎡', 'إ': '𐎢',
    'ؤ': '𐎣', 'ژ': '𐎤', 'ي': '𐎥', 'ة': '𐎦', 'ِ': '𐎧',
    'ّ': '𐎨', 'ۀ': '𐎩', 'آ': '𐎪', 'ـ': '𐎫', '؛': '𐎬',
    '،': '𐎭', 'ريال': '𐎮', ',': '𐎯', ']': '𐎰', '[': '𐎱',
    '\\': '𐎲', '»': '𐎳', '&': '𐎴', '*': '𐎵', '(': '𐎶',
    ')': '𐎷'
    # بقیه کاراکترهای خاص را می‌توان اضافه کرد
}
)
persian_to_manichaean_mapping = {
    'آ': '𐫀', 'ا': '𐫀', 'ب': '𐫁', 'پ': '𐫡', 'ت': '𐫃',
    'ث': '𐫣', 'ج': '𐫄', 'چ': '𐫤', 'ح': '𐫅', 'خ': '𐫥',
    'د': '𐫆', 'ذ': '𐫦', 'ر': '𐫇', 'ز': '𐫧', 'ژ': '𐫨',
    'س': '𐫈', 'ش': '𐫩', 'ص': '𐫉', 'ض': '𐫪', 'ط': '𐫊',
    'ظ': '𐫫', 'ع': '𐫋', 'غ': '𐫬', 'ف': '𐫌', 'ق': '𐫭',
    'ک': '𐫍', 'گ': '𐫮', 'ل': '𐫎', 'م': '𐫏', 'ن': '𐫐',
    'و': '𐫑', 'ه': '𐫒', 'ی': '𐫓'
}
persian_to_cuneiform_mapping.update(
    {
    '-': '𐎽', '/': '𐏁', '+': '𐏃', '÷': '𐏄', '!': '𐏂',
    '#': '𐏃', '%': '𐏀', '^': '𐎼', '$': '𐏅', '"': '𐎿',
    '>': '𐏆', '<': '𐏇', 'ء': '𐎠', 'أ': '𐎡', 'إ': '𐎢',
    'ؤ': '𐎣', 'ژ': '𐎤', 'ي': '𐎥', 'ة': '𐎦', 'ِ': '𐎧',
    'ّ': '𐎨', 'ۀ': '𐎩', 'آ': '𐎪', 'ـ': '𐎫', '؛': '𐎬',
    '،': '𐎭', 'ريال': '𐎮', ',': '𐎯', ']': '𐎰', '[': '𐎱',
    '\\': '𐎲', '»': '𐎳', '&': '𐎴', '*': '𐎵', '(': '𐎶',
    ')': '𐎷'
    # بقیه کاراکترهای خاص را می‌توان اضافه کرد
}
)
persian_to_manichaean_mapping.update(
    {'ئ':'𐎠'}
)

english_to_pahlavi_mapping.update({
    '0': '𐏎', '1': '𐏑', '2': '𐏒', '3': '𐏓', '4': '𐏔',
    '5': '𐏕', '6': '𐏖', '7': '𐏗', '8': '𐏘', '9': '𐏙'
})

english_to_manichaean_mapping.update({
    '0': '𐫰', '1': '𐫱', '2': '𐫲', '3': '𐫳', '4': '𐫴',
    '5': '𐫵', '6': '𐫶', '7': '𐫷', '8': '𐫸', '9': '𐫹'
})

english_to_cuneiform_mapping.update({
    '0': '𒐀', '1': '𒐁', '2': '𒐂', '3': '𒐃', '4': '𒐄',
    '5': '𒐅', '6': '𒐆', '7': '𒐇', '8': '𒐈', '9': '𒐉'
})


english_to_cuneiform_mapping.update(
    {
    '-': '𐎽', '/': '𐏁', '+': '𐏃', '÷': '𐏄', '!': '𐏂',
    '#': '𐏃', '%': '𐏀', '^': '𐎼', '$': '𐏅', '"': '𐎿',
    '>': '𐏆', '<': '𐏇', 'ء': '𐎠', 'أ': '𐎡', 'إ': '𐎢',
    'ؤ': '𐎣', 'ژ': '𐎤', 'ي': '𐎥', 'ة': '𐎦', 'ِ': '𐎧',
    'ّ': '𐎨', 'ۀ': '𐎩', 'آ': '𐎪', 'ـ': '𐎫', '؛': '𐎬',
    '،': '𐎭', 'ريال': '𐎮', ',': '𐎯', ']': '𐎰', '[': '𐎱',
    '\\': '𐎲', '»': '𐎳', '&': '𐎴', '*': '𐎵', '(': '𐎶',
    ')': '𐎷'
    # بقیه کاراکترهای خاص را می‌توان اضافه کرد
}
)


english_to_hieroglyph_mapping = {
    'A': '𓀀', 'B': '𓃀', 'C': '𓍿', 'D': '𓂧', 'E': '𓇋',
    'F': '𓆑', 'G': '𓎼', 'H': '𓉔', 'I': '𓇋', 'J': '𓊃',
    'K': '𓎡', 'L': '𓃭', 'M': '𓈖', 'N': '𓈖', 'O': '𓂋',
    'P': '𓊪', 'Q': '𓏘', 'R': '𓂋', 'S': '𓋴', 'T': '𓏏',
    'U': '𓅱', 'V': '𓆑', 'W': '𓅱', 'X': '𓐙', 'Y': '𓇌',
    'Z': '𓊃',
    'a': '𓀀', 'b': '𓃀', 'c': '𓍿', 'd': '𓂧', 'e': '𓇋',
    'f': '𓆑', 'g': '𓎼', 'h': '𓉔', 'i': '𓇋', 'j': '𓊃',
    'k': '𓎡', 'l': '𓃭', 'm': '𓈖', 'n': '𓈖', 'o': '𓂋',
    'p': '𓊪', 'q': '𓏘', 'r': '𓂋', 's': '𓋴', 't': '𓏏',
    'u': '𓅱', 'v': '𓆑', 'w': '𓅱', 'x': '𓐙', 'y': '𓇌',
    'z': '𓊃'
}

# مپینگ هیروگلیف به فارسی
persian_to_hieroglyph_mapping = {
    'آ': '𓀀', 'ا': '𓀀', 'ب': '𓃀', 'پ': '𓊪', 'ت': '𓏏',
    'ث': '𓋴', 'ج': '𓍿', 'چ': '𓊃', 'ح': '𓉔', 'خ': '𓎼',
    'د': '𓂧', 'ذ': '𓋴', 'ر': '𓂋', 'ز': '𓊃', 'ژ': '𓍿',
    'س': '𓋴', 'ش': '𓋴', 'ص': '𓋴', 'ض': '𓋴', 'ط': '𓏏',
    'ظ': '𓋴', 'ع': '𓀀', 'غ': '𓎼', 'ف': '𓆑', 'ق': '𓏘',
    'ک': '𓎡', 'گ': '𓎼', 'ل': '𓃭', 'م': '𓈖', 'ن': '𓈖',
    'و': '𓅱', 'ه': '𓉔', 'ی': '𓇌'
}



    
linear_b_dict = {
    
    "a": "𐀀", "A": "𐁀", "b": "𐀁", "B": "𐁁", "c": "𐀂", "C": "𐁂",
    "d": "𐀃", "D": "𐁃", "e": "𐀄", "E": "𐁄", "f": "𐀅", "F": "𐁅",
    "g": "𐀆", "G": "𐁆", "h": "𐀇", "H": "𐁇", "i": "𐀈", "I": "𐁈",
    "j": "𐀉", "J": "𐁉", "k": "𐀊", "K": "𐁊", "l": "𐀋", "L": "𐁋",
    "m": "𐀌", "M": "𐁌", "n": "𐀍", "N": "𐁍", "o": "𐀎", "O": "𐁎",
    "p": "𐀏", "P": "𐁏", "q": "𐀐", "Q": "𐁐", "r": "𐀑", "R": "𐁑",
    "s": "𐀒", "S": "𐁒", "t": "𐀓", "T": "𐁓", "u": "𐀔", "U": "𐁔",
    "v": "𐀕", "V": "𐁕", "w": "𐀖", "W": "𐁖", "x": "𐀗", "X": "𐁗",
    "y": "𐀘", "Y": "𐁘", "z": "𐀙", "Z": "𐁙",

    # حروف فارسی
    "ا": "𐀀", "ب": "𐀁", "پ": "𐀏", "ت": "𐀓", "ث": "𐀒", 
    "ج": "𐀉", "چ": "𐀇", "ح": "𐀄", "خ": "𐀊", "د": "𐀃", 
    "ذ": "𐀄", "ر": "𐀑", "ز": "𐀙", "ژ": "𐀖", "س": "𐀒", 
    "ش": "𐀕", "ص": "𐀒", "ض": "𐀓", "ط": "𐀓", "ظ": "𐀑", 
    "ع": "𐀀", "غ": "𐀆", "ف": "𐀅", "ق": "𐀐", "ک": "𐀊", 
    "گ": "𐀆", "ل": "𐀋", "م": "𐀌", "ن": "𐀍", "و": "𐀎", 
    "ه": "𐀇", "ی": "𐀘",

 
    "0": "𐄁", "1": "𐄀", "2": "𐄂", "3": "𐄃", "4": "𐄄",
    "5": "𐄅", "6": "𐄆", "7": "𐄇", "8": "𐄈", "9": "𐄉",


    " ": " ", ".": "𐄁", ",": "𐄂", "?": "𐄃", "!": "𐄄"
}
conversion_dict = {
    # حروف فارسی
    'ا': '𒀀', 'ب': '𒁀', 'پ': '𒉿', 'ت': '𒋾', 'ث': '𒍝',
    'ج': '𒅆', 'چ': '𒌑', 'ح': '𒄣', 'خ': '𒆪', 'د': '𒁲',
    'ذ': '𒍣', 'ر': '𒊑', 'ز': '𒍢', 'ژ': '𒌑', 'س': '𒊓',
    'ش': '𒐈', 'ص': '𒍑', 'ض': '𒄭', 'ط': '𒋫', 'ظ': '𒆸',
    'ع': '𒀊', 'غ': '𒂷', 'ف': '𒉺', 'ق': '𒆳', 'ک': '𒆠',
    'گ': '𒄖', 'ل': '𒇻', 'م': '𒈬', 'ن': '𒉡', 'و': '𒉿',
    'ه': '𒄩', 'ی': '𒅀',

    # حروف انگلیسی (بزرگ و کوچک هر دو با یک نماد)
    'a': '𒀀', 'b': '𒁀', 'c': '𒍝', 'd': '𒁲', 'e': '𒂊',
    'f': '𒉺', 'g': '𒄖', 'h': '𒄩', 'i': '𒅀', 'j': '𒅆',
    'k': '𒆠', 'l': '𒇻', 'm': '𒈬', 'n': '𒉡', 'o': '𒍪',
    'p': '𒉿', 'q': '𒆳', 'r': '𒊑', 's': '𒊓', 't': '𒋾',
    'u': '𒌑', 'v': '𒉺', 'w': '𒉿', 'x': '𒅆', 'y': '𒅀',
    'z': '𒍢',

    # اعداد
    '0': '𒐕', '1': '𒐖', '2': '𒐗', '3': '𒐘', '4': '𒐙',
    '5': '𒐚', '6': '𒐛', '7': '𒐜', '8': '𒐝', '9': '𒐞',

    # علائم نگارشی و فاصله‌ها
    ' ': ' ', '.': '𒑰', ',': '𒑱', '!': '𒈠', '?': '𒈡'
}

def convert_to_cuneiform(text):
    return ''.join(english_to_cuneiform_mapping.get(char, persian_to_cuneiform_mapping.get(char, char)) for char in text)

def convert_to_pahlavi(text):
    return ''.join(english_to_pahlavi_mapping.get(char, persian_to_pahlavi_mapping.get(char, char)) for char in text)

def convert_to_manichaean(text):
    return ''.join(english_to_manichaean_mapping.get(char, persian_to_manichaean_mapping.get(char, char)) for char in text)

def convert_to_hieroglyph(text):
    return ''.join(english_to_hieroglyph_mapping.get(char, persian_to_hieroglyph_mapping.get(char, char)) for char in text)
def text_to_linear_b_optimized(text):
    # بررسی کاراکتر به کاراکتر و جایگزینی آنها با خط میکنی
    return ''.join([linear_b_dict.get(char, char) for char in text])

def convert_to_akkadian(text):
    return ''.join([conversion_dict.get(char.lower(), char) for char in text])

# به فایل ancientscripts.py این بخش را اضافه کنید
oracle_bone_dict = {
    # حروف انگلیسی
    'a': '𠁣', 'b': '𠁢', 'c': '𠂋', 'd': '𠀂', 'e': '𠀀',
    'f': '𠂤', 'g': '𠁨', 'h': '𠁧', 'i': '𠀁', 'j': '𠂉',
    'k': '𠁩', 'l': '𠁪', 'm': '𠁫', 'n': '𠁬', 'o': '𠁭',
    'p': '𠁮', 'q': '𠁯', 'r': '𠁰', 's': '𠁱', 't': '𠁲',
    'u': '𠁳', 'v': '𠁴', 'w': '𠁵', 'x': '𠁶', 'y': '𠁷', 
    'z': '𠁸',
    
    # حروف فارسی
    'ا': '日', 'ب': '月', 'پ': '山', 'ت': '水', 'ث': '火',
    'ج': '木', 'چ': '人', 'ح': '口', 'خ': '手', 'د': '目',
    'ذ': '田', 'ر': '足', 'ز': '子', 'ژ': '女', 'س': '男',
    'ش': '雨', 'ص': '魚', 'ض': '鳥', 'ط': '馬', 'ظ': '牛',
    'ع': '羊', 'غ': '犬', 'ف': '龍', 'ق': '虎', 'ک': '鹿',
    'گ': '象', 'ل': '龜', 'م': '貝', 'ن': '虫', 'و': '心',
    'ه': '門', 'ی': '車',
    
    # اعداد
    '0': '〇', '1': '一', '2': '二', '3': '三', '4': '四',
    '5': '五', '6': '六', '7': '七', '8': '八', '9': '九',
    
    # علائم نگارشی
    ' ': '　', ',': '、', '.': '。', '!': '！', '?': '？',
    '\n': '\n'
}

def convert_to_oracle_bone(text):
    """تبدیل متن به خط چینی باستان"""
    result = []
    for char in text:
        # نرمال سازی کاراکترها
        char = unicodedata.normalize('NFKC', char)
        # جستجو در دیکشنری (حساس به بزرگی و کوچکی حروف)
        translated = oracle_bone_dict.get(char, 
                    oracle_bone_dict.get(char.lower(), char))
        result.append(translated)
    return ''.join(result)